#!/usr/local/bin/perl

# Use as nmrview2tbl.pl <input NMRview peak file> <output name> <assigned.outname>

# This version (30/05/99) removes diagonal peaks from list
# (first two dimensions within 0.05 ppm of each other)

$file=$ARGV[0];
$outfile=$ARGV[1];
$outfile1=$ARGV[2];
open (FILE,$file)||die "No such file as '$file': $!";
open (OUT,">$outfile")||die "Couldn't open $outfile: $!";
open (OUTFILE,">$outfile1")||die "Couldn't open $outfile1: $!";

@dims=qw(first second third);

for $i (0...$#dims) {
	while ($minrange[$i] eq "" || $minrange[$i] !~ /\d*\.\d+/) {
		print "Enter minimal chemical shift window in $dims[$i] dimension: ";
		chomp ($minrange[$i] = <STDIN>);
	}
}

$filter_min=4.72;
$filter_max=4.79;

while ($filteron eq "" || $filteron !~ /y|Y|n|N/) {
	printf "Do you want to filter out a certain ppm range (currently $filter_min-$filter_max) (y/n): ";
	chomp ($filteron = <STDIN>);
}

while ($vichoice eq "" || $vichoice !~ /i|I|v|V/) {
	printf "Do you want to include intensities (i) or volumes (v) in the .tbl file: ";
	chomp ($vichoice = <STDIN>);
}

while (defined ($_=<FILE>)) {
	chomp;
	s/\!+.*//g;
	next if ($_ =~ /^\s*$/);
	($pnum,$v1,$dim[0],$v2,$dimdev[0],$v3,$v4,$v5,$v6,$dim[1],$v7,$dimdev[1],$v8,$v9,$v10,$v11,$dim[2],$v12,$dimdev[2],$v13,$v14,$v15,$vol,$int,@void)=split(' ');
	next if ($dim[0] !~ /\d+\.\d+/ || $dim[1] !~ /\d+\.\d+/);
	next if ($dim[0]-$dim[1] < 0.05 && $dim[0]-$dim[1] > -0.05); # removes diagonal peaks
	
	
	if ($v1 ne "{?}"  && $v6 !~ /:/ ){
	#print $v1
	#$string =~ s/{/wank/;
	#print  "$v1 $v6 $string\n";
	printf OUTFILE ("assi ( resid %s and name %s )\n",
				$v1,$v1);
	printf OUTFILE ("     ( resid %s and name %s )\n",
				$v6, $v6);
	printf OUTFILE ("  6 0.1 0.1  peak  %d  volume  %f  ppm1  %6.3f  ppm2  %6.3f\n",
				$pnum,$int,$dim[0],$dim[1]);	
	
	
	}
	
	if ($v1 ne "{?}"  && $v6 =~ /:/ ){
	#print $v1
	#$string =~ s/{/wank/;
	#print  "$v1 $v6 $string\n";
	printf OUTFILE ("assi ( resid %s and name %s )\n",
				$v1,$v1);
	printf	OUTFILE ("     ( resid %s and name %s )\n",
				$v6, $v6);
	printf OUTFILE ("  6 0.1 0.1  peak  %d  volume  %f  ppm1  %6.3f  ppm2  %6.3f\n",
				$pnum,$int,$dim[0],$dim[1]);	
	
	
	}
	
	
	
	else
	
	
	
	{
	if ($filteron =~ /y|Y/) {
		next if ($dim[1]>$filter_min && $dim[1]<$filter_max);
	}
	if ($vichoice =~ /i|I/) {
		$vol=$int;
	}
	
	for $i (0...$#dims) {
		if ($dimdev[$i]/2 < $minrange[$i]) {
			$dimdev[$i] = $minrange[$i];
		}
		else {$dimdev[$i]/=2;}
	
	}
	
#	if ($v1 = "{?}"){
#	print $v1
#	}
#	if ($v1 = H ) {
#	print $v1
#	}
#	
	
	
	
	printf OUT ("assi ( attr store1 < %6.4f and attr store1 > %6.4f )\n",
				$dim[1]+$dimdev[1],$dim[1]-$dimdev[1]);
	printf OUT ("     (( attr store1 < %6.4f and attr store1 > %6.4f )\n",
				$dim[0]+$dimdev[0],$dim[0]-$dimdev[0]);
	printf OUT ("     and bondedto ( attr store1 < %6.3f and attr store1 > %6.3f))\n",
				$dim[2]+$dimdev[2],$dim[2]-$dimdev[2]);
	printf OUT ("  6 0.1 0.1  peak  %d  volume  %f  ppm1  %6.3f  ppm2  %6.3f\n",
				$pnum,$vol,$dim[1],$dim[0]);
}
}
